namespace ConsoleApp3
{
    internal class Program
    {
        static void Res(int n, int k, int x, int[] a)
        {
            bool t = true;
            int c = 0, br = 0,p;
            SortedSet<int> b = new SortedSet<int>();
            for (int j = 1; j < k-1; j++)
            {
                b.Add(a[j]);
            }
            for (int i = 0; i <= n - k; i++)
            {
                t = true;
                c = 0;
                p = 0;
                b.Add(a[i+k-1]);
                if (i + k < n)
                    c = a[i + k];
                for (int j = 0; j < x - 1-p; j++)
                {
                    if (t && b.ElementAt(k - j - 2) - c < 0)
                    {
                        p++;
                        j--;
                        t = false;
                        continue;
                    }
                    br += b.ElementAt(k - j - 2) - c;
                }
                br += a[i] - c;
                Console.WriteLine(br);
                br = 0;
                c = 0;
                b.Remove(a[i+1]);
            }
        }
        static void Main(string[] args)
        {
            string[] c = Console.ReadLine().Split();
            int n = int.Parse(c[0]), k = int.Parse(c[1]), x = int.Parse(c[2]);
            int[] a = new int[n];
            c = Console.ReadLine().Split();
            a[n - 1] = int.Parse(c[n - 1]);
            for (int i = n - 2; i >= 0; i--)
            {
                a[i] = int.Parse(c[i]) + a[i + 1];
            }
            Res(n, k, x, a);
        }
    }
}